searchPane = {
    //clear
    delayedClearLabel: null,
    delayedClearInput: null,
    delayedClearUnits: null,
    cancelClearCbox: null,
    //reset
    engineMenu: null,
    enginePopup: null,
    delayedResetLabel: null,
    delayedResetInput: null,
    delayedResetUnits: null,
    cancelResetCbox: null,
    //tabs
    detectionLabel: null,
    blankTabCbox: null,
    homeTabCbox: null,
    newTabCbox: null,

    buildEngineList: function()
    {
        const kXULNS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
        let defaultEnginePref = document.getElementById("extensions.searchload.defaultengine");
        let enginesExist = false;
        let engineWasFound = false;

        let searchService = Components.classes["@mozilla.org/browser/search-service;1"]
                            .getService(Components.interfaces.nsIBrowserSearchService);
        let engines = searchService.getVisibleEngines({ });

        if(engines.length > 0)
        {
            enginesExist = true;
            for(let i=0; i < engines.length; i++)
            {
                let menuitem = document.createElementNS(kXULNS, "menuitem");
                menuitem.setAttribute("label", engines[i].name);
                menuitem.setAttribute("value", engines[i].name);
                menuitem.setAttribute("class", "menuitem-iconic engine-icon");
                if( engines[i].iconURI )
                    menuitem.setAttribute("image", engines[i].iconURI.spec);
                this.enginePopup.appendChild(menuitem);
                if(engines[i].name == defaultEnginePref.value)
                {
                    this.engineMenu.selectedIndex = i;
                    engineWasFound = true;
                }
            }
        }

        if(enginesExist && !engineWasFound)
            defaultEnginePref.valueFromPreferences = engines[0].name;
    },//buildEngineList

    init: function()
    {
        this.delayedClearLabel = document.getElementById("delayedclear-label");
        this.delayedClearInput = document.getElementById("delayedclear-input");
        this.delayedClearUnits = document.getElementById("delayedclear-units");
        this.cancelClearCbox = document.getElementById("cancelclear-checkbox");

        this.engineMenu  = document.getElementById("engine-menu");
        this.enginePopup = document.getElementById("engine-popup");
        this.delayedResetLabel = document.getElementById("delayedreset-label");
        this.delayedResetInput = document.getElementById("delayedreset-input");
        this.delayedResetUnits = document.getElementById("delayedreset-units");
        this.cancelResetCbox = document.getElementById("cancelreset-checkbox");

        this.detectionLabel = document.getElementById("detection-label");
        this.blankTabCbox = document.getElementById("detectblank-checkbox");
        this.homeTabCbox  = document.getElementById("detecthome-checkbox");
        this.newTabCbox  = document.getElementById("detectnewtab-checkbox");

        this.buildEngineList();

        let clearSearchBarPref = document.getElementById("extensions.searchload.clearonsearch");
        let resetSearchBarPref = document.getElementById("extensions.searchload.resetonsearch");
        let tabcontrolPref     = document.getElementById("extensions.searchload.newtab");

        this.updateDetect(tabcontrolPref.value);
        this.updateClearStatus(clearSearchBarPref.value);
        this.updateResetStatus(resetSearchBarPref.value);
    },//init

    updateClearStatus: function(boolVal)
    {
        let clearDelayPref = document.getElementById("extensions.searchload.cleardelay");
        this.delayedClearLabel.disabled = !boolVal;
        this.delayedClearInput.disabled = !boolVal;
        this.delayedClearUnits.disabled = !boolVal;
        this.updateCancelClear( clearDelayPref.value===0 || !boolVal);
    },

    updateCancelClear: function(disable)
    {
        if(disable)
            this.cancelClearCbox.disabled = true;
        else
            this.cancelClearCbox.disabled = false;
    },

    updateResetStatus: function(boolVal)
    {
        let resetDelayPref = document.getElementById("extensions.searchload.resetdelay");
        this.engineMenu.disabled = !boolVal;
        this.delayedResetLabel.disabled = !boolVal;
        this.delayedResetInput.disabled = !boolVal;
        this.delayedResetUnits.disabled = !boolVal;
        this.updateCancelReset( resetDelayPref.value===0 || !boolVal);
    },

    updateCancelReset: function(disable)
    {
        if(disable)
            this.cancelResetCbox.disabled = true;
        else
            this.cancelResetCbox.disabled = false;
    },

    updateDetect: function(index)
    {
        if(index===0)
        {   this.detectionLabel.disabled = true;
            this.blankTabCbox.disabled = true;
            this.homeTabCbox.disabled = true;
            this.newTabCbox.disabled = true;
        }
        else
        {   this.detectionLabel.disabled = false;
            this.blankTabCbox.disabled = false;
            this.homeTabCbox.disabled = false;
            this.newTabCbox.disabled = false;
        }
    }
};
